unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, db, memds, Forms, Controls, Graphics, Dialogs, StdCtrls,
  Spin, DBGrids, IBCustomDataSet, IBTable, DateTimePicker, rxmemds, rxdbgrid;

type

  { TForm1 }

  TForm1 = class(TForm)
    btnAdd: TButton;
    btnEdt: TButton;
    btnDel: TButton;
    btnLeft: TButton;
    btnRight: TButton;
    CheckBox1: TCheckBox;
    DS: TDataSource;
    DateTimePicker1: TDateTimePicker;
    Edit1: TEdit;
    GroupBox1: TGroupBox;
    MD1: TMemDataset;
    MDBoolFld: TBooleanField;
    MDDTFld: TDateTimeField;
    MDIntFld: TLongintField;
    MDMemoFld: TMemoField;
    MDStrFld: TStringField;
    Memo1: TMemo;
    DBGrid: TRxDBGrid;
    MD: TRxMemoryData;
    SpinEdit1: TSpinEdit;
    procedure btnAddClick(Sender: TObject);
    procedure btnDelClick(Sender: TObject);
    procedure btnEdtClick(Sender: TObject);
    procedure btnLeftClick(Sender: TObject);
    procedure btnRightClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure InitMode(Sender: TObject);
    procedure EditMode(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  {$IFDEF LINUX}
  btnLeft.Caption:= 'Отмена';
  btnRight.Caption:= 'Сохранить';
  {$ELSE}
  btnLeft.Caption:= 'Сохранить';
  btnRight.Caption:= 'Отмена';
  {$ENDIF}
end;

procedure TForm1.btnLeftClick(Sender: TObject);
begin
  {$IFDEF LINUX}
  MD.Cancel;
  {$ELSE}
  MD.AppendRecord([CheckBox1.Checked,Edit1.Text,DateTimePicker1.DateTime,SpinEdit1.Value,Memo1.Text]);
  {$ENDIF}

  InitMode(Sender);
end;

procedure TForm1.btnAddClick(Sender: TObject);
begin
  EditMode(Sender);
end;

procedure TForm1.btnDelClick(Sender: TObject);
begin
  EditMode(Sender);
end;

procedure TForm1.btnEdtClick(Sender: TObject);
begin
  EditMode(Sender);
end;

procedure TForm1.btnRightClick(Sender: TObject);
begin
  {$IFDEF LINUX}
  MD.Cancel;
  {$ELSE}
  MD.AppendRecord([CheckBox1.Checked,Edit1.Text,DateTimePicker1.DateTime,SpinEdit1.Value,Memo1.Text]);
  {$ENDIF}

  InitMode(Sender);
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  MD.Open;
  InitMode(Sender);
end;

procedure TForm1.InitMode(Sender: TObject);
begin
  if MD.IsEmpty
    then DS.DataSet:= nil
    else DS.DataSet:= MD;

  GroupBox1.Visible:= False;
  btnAdd.Enabled:= True;
  btnEdt.Enabled:= not MD.IsEmpty;
  btnDel.Enabled:= not MD.IsEmpty;
  DBGrid.Enabled:= not MD.IsEmpty;

  if DBGrid.Enabled
    then
      DBGrid.TitleFont.Color:= clDefault
    else
      DBGrid.TitleFont.Color:= clGray;

end;

procedure TForm1.EditMode(Sender: TObject);
begin
  GroupBox1.Visible:= True;
  btnAdd.Enabled:= not GroupBox1.Visible;
  btnEdt.Enabled:= not GroupBox1.Visible;
  btnDel.Enabled:= not GroupBox1.Visible;
  DBGrid.Enabled:= not GroupBox1.Visible;

  if MD.Active then MD.Edit;
end;

end.

